# wxHeaderCtrl Class Reference
[Controls]

`#include <wx/headerctrl.h>`

Inheritance diagram for wxHeaderCtrl:
[legend]

## Detailed Description

wxHeaderCtrl is the control containing the column headings which is usually used for display of tabular data.

It is used as part of wxGrid, in generic version wxDataViewCtrl and report view of wxListCtrl but can be also used independently. In general this class is meant to be used as part of another control which already stores the column information somewhere as it can't be used directly: instead you need to inherit from it and implement the GetColumn() method to provide column information. See wxHeaderCtrlSimple for a concrete control class which can be used directly.

In addition to labeling the columns, the control has the following features:

- Column reordering support, either by explicitly configuring the columns order and calling SetColumnsOrder() or by dragging the columns interactively (if enabled).
- Display of the icons in the header: this is often used to display a sort or reverse sort indicator when the column header is clicked.

Notice that this control itself doesn't do anything other than displaying the column headers. In particular column reordering and sorting must still be supported by the associated control displaying the real data under the header. Also remember to call ScrollWindow() method of the control if the associated data display window has a horizontal scrollbar, otherwise the headers wouldn't align with the data when the window is scrolled.

This control is implemented using the native header control under MSW systems and a generic implementation elsewhere.

## Future Improvements

Some features are supported by the native MSW control and so could be easily implemented in this version of wxHeaderCtrl but need to be implemented in the generic version as well to be really useful. Please let us know if you need or, better, plan to work on implementing, any of them:

- Displaying bitmaps instead of or together with the text
- Custom drawn headers
- Filters associated with a column.

## Styles

This class supports the following styles:

- wxHD_ALLOW_REORDER:
  If this style is specified (it is by default), the user can reorder the control columns by dragging them.
- wxHD_ALLOW_HIDE:
  If this style is specified, the control shows a popup menu allowing the user to change the columns visibility on right mouse click. Notice that the program can always hide or show the columns, this style only affects the users capability to do it.
- wxHD_DEFAULT_STYLE:
  Symbolic name for the default control style, currently equal to `wxHD_ALLOW_REORDER`.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxHeaderCtrlEvent& event)
Event macros for events emitted by this class:

- EVT_HEADER_CLICK(id, func):
  A column heading was clicked.
- EVT_HEADER_RIGHT_CLICK(id, func):
  A column heading was right clicked.
- EVT_HEADER_MIDDLE_CLICK(id, func):
  A column heading was clicked with the middle mouse button.
- EVT_HEADER_DCLICK(id, func):
  A column heading was double clicked.
- EVT_HEADER_RIGHT_DCLICK(id, func):
  A column heading was right double clicked.
- EVT_HEADER_MIDDLE_DCLICK(id, func):
  A column heading was double clicked with the middle mouse button.
- EVT_HEADER_SEPARATOR_DCLICK(id, func):
  Separator to the right of the specified column was double clicked (this action is commonly used to resize the column to fit its contents width and the control provides UpdateColumnWidthToFit() method to make implementing this easier).
- EVT_HEADER_BEGIN_RESIZE(id, func):
  The user started to drag the separator to the right of the column with the specified index (this can only happen for the columns for which wxHeaderColumn::IsResizeable() returns true). The event can be vetoed to prevent the column from being resized. If it isn't, the resizing and end resize (or dragging cancelled) events will be generated later.
- EVT_HEADER_RESIZING(id, func):
  The user is dragging the column with the specified index resizing it and its current width is wxHeaderCtrlEvent::GetWidth(). The event can be vetoed to stop the dragging operation completely at any time.
- EVT_HEADER_END_RESIZE(id, func):
  The user stopped dragging the column by releasing the mouse. The column should normally be resized to the value of wxHeaderCtrlEvent::GetWidth().
- EVT_HEADER_BEGIN_REORDER(id, func):
  The user started to drag the column with the specified index (this can only happen for the controls with wxHD_ALLOW_REORDER style). This event can be vetoed to prevent the column from being reordered, otherwise the end reorder message will be generated later.
- EVT_HEADER_END_REORDER(id, func):
  The user dropped the column in its new location. The event can be vetoed to prevent the column from being placed at the new position or handled to update the display of the data in the associated control to match the new column location (available from wxHeaderCtrlEvent::GetNewOrder()).
- EVT_HEADER_DRAGGING_CANCELLED(id, func):
  The resizing or reordering operation currently in progress was cancelled. This can happen if the user pressed Esc key while dragging the mouse or the mouse capture was lost for some other reason. You only need to handle this event if your application entered into some modal mode when resizing or reordering began, in which case it should handle this event in addition to the matching end resizing or reordering ones.

##

Library: wxCore

Category: Controls

See also:
  wxGrid, wxListCtrl, wxDataViewCtrl

## Public Member Functions
| wxHeaderCtrl ()
| Default constructor not creating the underlying window.
| wxHeaderCtrl (wxWindow *parent, wxWindowID winid=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxHD_DEFAULT_STYLE, const wxString &name=wxHeaderCtrlNameStr)
| Constructor creating the window.
bool | Create (wxWindow *parent, wxWindowID winid=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxHD_DEFAULT_STYLE, const wxString &name=wxHeaderCtrlNameStr)
| Create the header control window.
void | SetColumnCount (unsigned int count)
| Set the number of columns in the control.
unsigned int | GetColumnCount () const
| Return the number of columns in the control.
bool | IsEmpty () const
| Return whether the control has any columns.
void | UpdateColumn (unsigned int idx)
| Update the column with the given index.
void | SetColumnsOrder (const wxArrayInt &order)
| Change the columns display order.
wxArrayInt | GetColumnsOrder () const
| Return the array describing the columns display order.
unsigned int | GetColumnAt (unsigned int pos) const
| Return the index of the column displayed at the given position.
unsigned int | GetColumnPos (unsigned int idx) const
| Get the position at which this column is currently displayed.
void | ResetColumnsOrder ()
| Reset the columns order to the natural one.
bool | ShowColumnsMenu (const wxPoint &pt, const wxString &title=wxString())
| Show the popup menu allowing the user to show or hide the columns.
void | AddColumnsItems (wxMenu &menu, int idColumnsBase=0)
| Helper function appending the checkable items corresponding to all the columns to the given menu.
bool | ShowCustomizeDialog ()
| Show the column customization dialog.
## Static Public Member Functions
static void | MoveColumnInOrderArray (wxArrayInt &order, unsigned int idx, unsigned int pos)
| Helper function to manipulate the array of column indices.
## Protected Member Functions
virtual const wxHeaderColumn & | GetColumn (unsigned int idx) const =0
| Method to be implemented by the derived classes to return the information for the given column.
virtual void | UpdateColumnVisibility (unsigned int idx, bool show)
| Method called when the column visibility is changed by the user.
virtual void | UpdateColumnsOrder (const wxArrayInt &order)
| Method called when the columns order is changed in the customization dialog.
virtual bool | UpdateColumnWidthToFit (unsigned int idx, int widthTitle)
| Method which may be implemented by the derived classes to allow double clicking the column separator to resize the column to fit its contents.
virtual void | OnColumnCountChanging (unsigned int count)
| Can be overridden in the derived class to update internal data structures when the number of the columns in the control changes.

List of all members.

## Constructor & Destructor Documentation

wxHeaderCtrl::wxHeaderCtrl | ( |  | ) |

Default constructor not creating the underlying window.

You must use Create() after creating the object using this constructor.

wxHeaderCtrl::wxHeaderCtrl | ( | wxWindow * | parent,
|  | wxWindowID | winid = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxHD_DEFAULT_STYLE`,
|  | const wxString & | name = `wxHeaderCtrlNameStr` |
| ) |  |  |

Constructor creating the window.

Please see Create() for the parameters documentation.

## Member Function Documentation

void wxHeaderCtrl::AddColumnsItems | ( | wxMenu & | menu,
|  | int | idColumnsBase = `0` |
| ) |  |  |

Helper function appending the checkable items corresponding to all the columns to the given menu.

This function is used by ShowColumnsMenu() but can also be used if you show your own custom columns menu and still want all the columns shown in it. It appends menu items with column labels as their text and consecutive ids starting from idColumnsBase to the menu and checks the items corresponding to the currently visible columns.

Example of use:

                wxMenu menu;
                menu.Append(100, "Some custom command");
                menu.AppendSeparator();
                AddColumnsItems(menu, 200);
                const int rc = GetPopupMenuSelectionFromUser(menu, pt);
                if ( rc >= 200 )
                    ... toggle visibility of the column rc-200 ...

Parameters:

  | menu | The menu to append the items to. It may be currently empty or not.
  | idColumnsBase | The id for the menu item corresponding to the first column, the other ones are consecutive starting from it. It should be positive.

bool wxHeaderCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | winid = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxHD_DEFAULT_STYLE`,
|  | const wxString & | name = `wxHeaderCtrlNameStr` |
| ) |  |  |

Create the header control window.

Parameters:

  | parent | The parent window. The header control should be typically positioned along the top edge of this window.
  | winid | Id of the control or `wxID_ANY` if you don't care.
  | pos | The initial position of the control.
  | size | The initial size of the control (usually not very useful as this control will typically be resized to have the same width as the associated data display control).
  | style | The control style, `wxHD_DEFAULT_STYLE` by default. Notice that the default style allows the user to reorder the columns by dragging them and you need to explicitly turn this feature off by using
       wxHD_DEFAULT_STYLE & ~wxHD_ALLOW_REORDER
  if this is undesirable.
  | name | The name of the control.

Reimplemented from wxWindow.

virtual const wxHeaderColumn& wxHeaderCtrl::GetColumn | ( | unsigned int | idx | ) | const`[protected, pure virtual]`

Method to be implemented by the derived classes to return the information for the given column.

Parameters:

  | idx | The column index, between 0 and the value last passed to SetColumnCount().

unsigned int wxHeaderCtrl::GetColumnAt | ( | unsigned int | pos | ) | const

Return the index of the column displayed at the given position.

Parameters:

  | pos | The display position, e.g. 0 for the left-most column, 1 for the next one and so on until GetColumnCount() - 1.

See also:
  GetColumnPos()

unsigned int wxHeaderCtrl::GetColumnCount | ( |  | ) | const

Return the number of columns in the control.

Returns:
  Number of columns as previously set by SetColumnCount().

See also:
  IsEmpty()

unsigned int wxHeaderCtrl::GetColumnPos | ( | unsigned int | idx | ) | const

Get the position at which this column is currently displayed.

Notice that a valid position is returned even for the hidden columns currently.

Parameters:

  | idx | The column index, must be less than GetColumnCount().

See also:
  GetColumnAt()

wxArrayInt wxHeaderCtrl::GetColumnsOrder | ( |  | ) | const

Return the array describing the columns display order.

For the controls without wxHD_ALLOW_REORDER style the returned array will be the same as was passed to SetColumnsOrder() previously or define the default order (with n-th element being n) if it hadn't been called. But for the controls with wxHD_ALLOW_REORDER style, the columns can be also reordered by user.

bool wxHeaderCtrl::IsEmpty | ( |  | ) | const

Return whether the control has any columns.

See also:
  GetColumnCount()

static void wxHeaderCtrl::MoveColumnInOrderArray | ( | wxArrayInt & | order,
|  | unsigned int | idx,
|  | unsigned int | pos |
| ) |  |  | `[static]`

Helper function to manipulate the array of column indices.

This function reshuffles the array of column indices indexed by positions (i.e. using the same convention as for SetColumnsOrder()) so that the column with the given index is found at the specified position.

Parameters:

  | order | Array containing the indices of columns in order of their positions.
  | idx | The index of the column to move.
  | pos | The new position for the column idx.

virtual void wxHeaderCtrl::OnColumnCountChanging | ( | unsigned int | count | ) | `[protected, virtual]`

Can be overridden in the derived class to update internal data structures when the number of the columns in the control changes.

This method is called by SetColumnCount() before effectively changing the number of columns.

The base class version does nothing but it is good practice to still call it from the overridden version in the derived class.

void wxHeaderCtrl::ResetColumnsOrder | ( |  | ) |

Reset the columns order to the natural one.

After calling this function, the column with index `idx` appears at position `idx` in the control.

void wxHeaderCtrl::SetColumnCount | ( | unsigned int | count | ) |

Set the number of columns in the control.

The control will use GetColumn() to get information about all the new columns and refresh itself, i.e. this method also has the same effect as calling UpdateColumn() for all columns but it should only be used if the number of columns really changed.

void wxHeaderCtrl::SetColumnsOrder | ( | const wxArrayInt & | order | ) |

Change the columns display order.

The display order defines the order in which the columns appear on the screen and does not affect the interpretation of indices by all the other class methods.

The order array specifies the column indices corresponding to the display positions.

Parameters:

  | order | A permutation of all column indices, i.e. an array of size GetColumnsOrder() containing all column indices exactly once. The n-th element of this array defines the index of the column shown at the n-th position from left (for the default left-to-right writing direction).

See also:
  wxListCtrl::SetColumnsOrder()

bool wxHeaderCtrl::ShowColumnsMenu | ( | const wxPoint & | pt,
|  | const wxString & | title = `wxString()` |
| ) |  |  |

Show the popup menu allowing the user to show or hide the columns.

This functions shows the popup menu containing all columns with check marks for the ones which are currently shown and allows the user to check or uncheck them to toggle their visibility. It is called from the default EVT_HEADER_RIGHT_CLICK handler for the controls which have wxHD_ALLOW_HIDE style. And if the column has wxHD_ALLOW_REORDER style as well, the menu also contains an item to customize the columns shown using which results in ShowCustomizeDialog() being called, please see its description for more details.

If a column was toggled, UpdateColumnVisibility() virtual function is called so it must be implemented for the controls with wxHD_ALLOW_HIDE style or if you call this function explicitly.

Parameters:

  | pt | The position of the menu, in the header window coordinates.
  | title | The title for the menu if not empty.

Returns:
  true if a column was shown or hidden or false if nothing was done, e.g. because the menu was cancelled.

bool wxHeaderCtrl::ShowCustomizeDialog | ( |  | ) |

Show the column customization dialog.

This function displays a modal dialog containing the list of all columns which the user can use to reorder them as well as show or hide individual columns.

If the user accepts the changes done in the dialog, the virtual methods UpdateColumnVisibility() and UpdateColumnsOrder() will be called so they must be overridden in the derived class if this method is ever called. Please notice that the user will be able to invoke it interactively from the header popup menu if the control has both wxHD_ALLOW_HIDE and wxHD_ALLOW_REORDER styles.

See also:
  wxRearrangeDialog

void wxHeaderCtrl::UpdateColumn | ( | unsigned int | idx | ) |

Update the column with the given index.

When the value returned by GetColumn() changes, this method must be called to notify the control about the change and update the visual display to match the new column data.

Parameters:

  | idx | The column index, must be less than GetColumnCount().

virtual void wxHeaderCtrl::UpdateColumnsOrder | ( | const wxArrayInt & | order | ) | `[protected, virtual]`

Method called when the columns order is changed in the customization dialog.

This method is only called from ShowCustomizeDialog() when the user changes the order of columns. In particular it is not called if a single column changes place because the user dragged it to the new location, the EVT_HEADER_END_REORDER event handler should be used to react to this.

A typical implementation in a derived class will update the display order of the columns in the associated control, if any. Notice that there is no need to call SetColumnsOrder() from it as wxHeaderCtrl does it itself.

The base class version doesn't do anything and must be overridden if this method is called.

Parameters:

  | order | The new column order. This array uses the same convention as SetColumnsOrder().

virtual void wxHeaderCtrl::UpdateColumnVisibility | ( | unsigned int | idx,
|  | bool | show |
| ) |  |  | `[protected, virtual]`

Method called when the column visibility is changed by the user.

This method is called from ShowColumnsMenu() or ShowCustomizeDialog() when the user interactively hides or shows a column. A typical implementation will simply update the internally stored column state. Notice that there is no need to call UpdateColumn() from this method as it is already done by wxHeaderCtrl itself.

The base class version doesn't do anything and must be overridden if this method is called.

Parameters:

  | idx | The index of the column whose visibility was toggled.
  | show | The new visibility value, true if the column is now shown or false if it is not hidden.

virtual bool wxHeaderCtrl::UpdateColumnWidthToFit | ( | unsigned int | idx,
|  | int | widthTitle |
| ) |  |  | `[protected, virtual]`

Method which may be implemented by the derived classes to allow double clicking the column separator to resize the column to fit its contents.

When a separator is double clicked, the default handler of EVT_HEADER_SEPARATOR_DCLICK event calls this function and refreshes the column if it returns true so to implement the resizing of the column to fit its width on header double click you need to implement this method using logic similar to this example:

                class MyHeaderColumn : public wxHeaderColumn
                {
                public:
                    ...

                    void SetWidth(int width) { m_width = width; }
                    virtual int GetWidth() const { return m_width; }

                private:
                    int m_width;
                };

                class MyHeaderCtrl : public wxHeaderCtrl
                {
                public:
                protected:
                    virtual wxHeaderColumn& GetColumn(unsigned int idx) const
                    {
                        return m_cols[idx];
                    }

                    virtual bool UpdateColumnWidthToFit(unsigned int idx, int widthTitle)
                    {
                        int widthContents = ... compute minimal width for column idx ...
                        m_cols[idx].SetWidth(wxMax(widthContents, widthTitle));
                        return true;
                    }

                    wxVector<MyHeaderColumn> m_cols;
                };

Base class version simply returns false.

Parameters:

  | idx | The zero-based index of the column to update.
  | widthTitle | Contains minimal width needed to display the column header itself and will usually be used as a starting point for the fitting width calculation.

Returns:
  true to indicate that the column was resized, i.e. GetColumn() now returns the new width value, and so must be refreshed or false meaning that the control didn't reach to the separator double click.

|  | [ top ]